routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CompanyController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\HomeController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Auth::routes();
Route::get('/', [HomeController::class, 'index'])->name('home');

Route::middleware(['auth'])->group(function () {
    Route::resource('companies', CompanyController::class);
    Route::resource('employees', EmployeeController::class);
});

app/Models/Company.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Company extends Model
{
    use HasFactory;
    
    protected $guarded = [''];
    
    public function employees() {
        return $this->hasMany(Employee::class);
    }
}

app/Models/Employee.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Employee extends Model
{
    use HasFactory;
    
    protected $fillable = ['first_name', 'last_name', 'email', 'phone', 'company_id'];


    public function company() {
        return $this->belongsTo(Company::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/CompanyController.php
<?php

namespace App\Http\Controllers;

use App\Models\Company;
use Illuminate\Http\Request;
use App\Http\Requests\CompanyStoreRequest;
use App\Traits\ImageToStore;

class CompanyController extends Controller {

    use ImageToStore;

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index() {
        
        $companies = Company::orderBy('created_at', 'desc')->paginate(15);

        return view('companies.index', compact('companies'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create() {
        
        return view('companies.create');
        
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CompanyStoreRequest $request) {
        
        $dataValid = $request->validated();

        $pathImage = $this->saveImage($request);

        $dataValid['logo'] = $pathImage;

        Company::create($dataValid);

        return redirect()->route('companies.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Company  $company
     * @return \Illuminate\Http\Response
     */
    public function show(Company $company) {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Company  $company
     * @return \Illuminate\Http\Response
     */
    public function edit(Company $company) {
        
        return view('companies.edit', compact('company'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Company  $company
     * @return \Illuminate\Http\Response
     */
    public function update(CompanyStoreRequest $request, Company $company) {
        
        $dataValid = $request->validated();

        $pathImage = $this->saveImage($request);

        $dataValid['logo'] = $pathImage;

        $company->update($dataValid);

        return redirect()->route('companies.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Company  $company
     * @return \Illuminate\Http\Response
     */
    public function destroy(Company $company) {
        
        $company->delete();
        
        return redirect()->route('companies.index');
    }

}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/EmployeeController.php
<?php

namespace App\Http\Controllers;

use App\Models\Employee;
use App\Models\Company;
use Illuminate\Http\Request;
use App\Http\Requests\EmployeeStoreRequest;

class EmployeeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $employees = Employee::orderBy('created_at', 'desc')->paginate(15);

        return view('employees.index', compact('employees'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $companies = Company::all();
        
        return view('employees.create', compact('companies'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(EmployeeStoreRequest $request)
    {

        Employee::create($request->validated());

        return redirect()->route('employees.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Employee  $employee
     * @return \Illuminate\Http\Response
     */
    public function show(Employee $employee)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Employee  $employee
     * @return \Illuminate\Http\Response
     */
    public function edit(Employee $employee)
    {
        $companies = Company::all();
        
        return view('employees.edit', compact('employee', 'companies'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Employee  $employee
     * @return \Illuminate\Http\Response
     */
    public function update(EmployeeStoreRequest $request, Employee $employee)
    {
        $employee->update($request->validated());

        return redirect()->route('employees.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Employee  $employee
     * @return \Illuminate\Http\Response
     */
    public function destroy(Employee $employee)
    {
        $employee->delete();
        
        return redirect()->route('employees.index');
    }
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

resources/views/companies/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Companies</div>

                <div class="card-body">
                   
                    <form method="post" action="{{route('companies.store')}}" enctype="multipart/form-data">
                        @csrf
                        <div class="mb-3">
                            <label for="exampleInputname" class="form-label">Name</label>
                            <input name="name" type="text" class="form-control" value="{{old('name')}}" id="exampleInputname">
                            @error('name')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputEmail1" class="form-label">Email address</label>
                            <input name="email" type="email" class="form-control" value="{{old('email')}}" id="exampleInputEmail1" aria-describedby="emailHelp">
                            @error('email')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputPhone" class="form-label">Phone</label>
                            <input name="phone" type="text" class="form-control" value="{{old('phone')}}" id="exampleInputPhone">
                            @error('phone')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputWebsite" class="form-label">Website</label>
                            <input name="website" type="text" class="form-control" value="{{old('website')}}" id="exampleInputWebsite">
                            @error('website')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputLogo" class="form-label">Logo</label>
                            <input name="logo" type="file" class="form-control" value="{{old('logo')}}" id="exampleInputLogo">
                            @error('logo')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-primary">Submit</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/companies/edit.blade.php
@extends('layouts.app')

@push ('scripts')
<script type="text/javascript">
    $(document).on('click','.close_image', function(){
       $(this).closest('.box-images').find('.old_image').val("");
       $(this).closest('.box-images').find('.show_image').attr("src", "");
       $(this).closest('.box-images').find('.close_image').remove();
    });
</script>
@endpush
@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Companies</div>

                <div class="card-body">
                   
                    <form method="post" action="{{route('companies.update', ['company' => $company->id])}}" enctype="multipart/form-data">
                        @csrf
                        {{ method_field('PUT') }}
                        <div class="mb-3">
                            <label for="exampleInputname" class="form-label">Name</label>
                            <input name="name" type="text" value="{{$company->name}}" class="form-control" id="exampleInputname">
                            @error('name')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputEmail1" class="form-label">Email address</label>
                            <input name="email" type="email" value="{{$company->email}}" class="form-control" id="exampleInputEmail1" aria-describedby="emailHelp">
                            @error('email')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputPhone" class="form-label">Phone</label>
                            <input name="phone" type="text" value="{{$company->phone}}" class="form-control" id="exampleInputPhone">
                            @error('phone')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputWebsite" class="form-label">Website</label>
                            <input name="website" type="text" value="{{$company->website}}" class="form-control" id="exampleInputWebsite">
                            @error('website')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3 box-images">
                            <label for="exampleInputLogo" class="form-label">Logo</label>
                            <div class="wrap_image">
                                <input class="old_image" type="hidden" name="old_logo" value="{{$company->logo}}">
                                <img class="show_image" src="{{url('storage/' . $company->logo)}}">
                                <img class="close_image" src="{{asset('img/close.jpeg')}}"/>
                            </div>
                            <input name="logo" type="file" value="" class="form-control" id="exampleInputLogo">
                            @error('logo')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-primary">Submit</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/companies/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header">Companies</div>

                <div class="card-body">
                    <a href="{{route('companies.create')}}" class="btn btn-success mt-3 mb-3" role="button" data-bs-toggle="button">Add</a>
                    <table class="table">
                        <thead>
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">Name</th>
                                <th scope="col">Email</th>
                                <th scope="col">Phone</th>
                                <th scope="col">Website</th>
                                <th scope="col">Logo</th>
                                <th scope="col">Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($companies as $company)
                            <tr>
                                <th scope="row">{{$company->id}}</th>
                                <td>{{$company->name}}</td>
                                <td>{{$company->email}}</td>
                                <td>{{$company->phone}}</td>
                                <td>{{$company->website}}</td>
                                <td>{{$company->logo}}</td>
                                <td>
                                    <div class="btn-group">
                                        <a href="{{route('companies.edit',['company' => $company->id])}}" class="btn btn-primary">Edit</a>
                                        <a onclick="event.preventDefault();
                                                     document.getElementById('delete-company').submit();" class="btn btn-danger">Delete</a>
                                    </div>
                                    <form id="delete-company" action="{{route('companies.destroy', ['company' => $company->id])}}" method="POST" class="d-none">
                                        @csrf
                                        {{ method_field('DELETE') }}
                                    </form>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                    <div class="pagination mt-5">
                        {{ $companies->links() }}
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/employees/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Employees</div>

                <div class="card-body">
                   
                    <form method="post" action="{{route('employees.store')}}" enctype="multipart/form-data">
                        @csrf
                        <div class="mb-3">
                            <label for="exampleInputFirst_name" class="form-label">First Name</label>
                            <input name="first_name" type="text" class="form-control" value="{{old('first_name')}}" id="exampleInputFirst_name">
                            @error('first_name')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputLast_name" class="form-label">Last Name</label>
                            <input name="last_name" type="text" class="form-control" value="{{old('last_name')}}" id="exampleInputLast_name">
                            @error('last_name')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputEmail1" class="form-label">Email address</label>
                            <input name="email" type="email" class="form-control" value="{{old('email')}}" id="exampleInputEmail1" aria-describedby="emailHelp">
                            @error('email')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputPhone" class="form-label">Phone</label>
                            <input name="phone" type="text" class="form-control" value="{{old('phone')}}" id="exampleInputPhone">
                            @error('phone')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <select name="company_id" class="form-select form-select-lg mb-3" aria-label="Default select example">
                                <option value="">Select company</option>
                                @foreach($companies as $company)
                                    @if(old('company_id') == $company->id)
                                        <option selected value="{{$company->id}}">{{$company->name}}</option>
                                    @else
                                        <option value="{{$company->id}}">{{$company->name}}</option>
                                    @endif
                                @endforeach
                            </select>
                            @error('company_id')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-primary">Submit</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/employees/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Employees</div>

                <div class="card-body">
                   
                    <form method="post" action="{{route('employees.update', ['employee' => $employee->id])}}" enctype="multipart/form-data">
                        @csrf
                        {{ method_field('PUT') }}
                        <div class="mb-3">
                            <label for="exampleInputFirst_name" class="form-label">First Name</label>
                            <input name="first_name" type="text" class="form-control" value="{{$employee->first_name}}" id="exampleInputFirst_name">
                            @error('first_name')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputLast_name" class="form-label">Last Name</label>
                            <input name="last_name" type="text" class="form-control" value="{{$employee->last_name}}" id="exampleInputLast_name">
                            @error('last_name')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputEmail1" class="form-label">Email address</label>
                            <input name="email" type="email" class="form-control" value="{{$employee->email}}" id="exampleInputEmail1" aria-describedby="emailHelp">
                            @error('email')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <label for="exampleInputPhone" class="form-label">Phone</label>
                            <input name="phone" type="text" class="form-control" value="{{$employee->phone}}" id="exampleInputPhone">
                            @error('phone')
                                <div class="form-text">{{$message}}</div>
                            @enderror
                        </div>
                        <div class="mb-3">
                            <select name="company_id" class="form-select form-select-lg mb-3" aria-label="Default select example">
                                <option value="">Select company</option>
                                @foreach($companies as $company)
                                    @if($employee->company_id) == $company->id)
                                        <option selected value="{{$company->id}}">{{$company->name}}</option>
                                    @else
                                        <option value="{{$company->id}}">{{$company->name}}</option>
                                    @endif
                                @endforeach
                            </select>
                        </div>
                        <button type="submit" class="btn btn-primary">Submit</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/employees/index.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header">Employees</div>

                <div class="card-body">
                    <a href="{{route('employees.create')}}" class="btn btn-success mt-3 mb-3" role="button" data-bs-toggle="button">Add</a>
                    <table class="table">
                        <thead>
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">First Name</th>
                                <th scope="col">Last Name</th>
                                <th scope="col">Email</th>
                                <th scope="col">Phone</th> 
                                <th scope="col">Company</th>
                                <th scope="col">Actions</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach($employees as $employee)
                            <tr>
                                <th scope="row">{{$employee->id}}</th>
                                <td>{{$employee->first_name}}</td>
                                <td>{{$employee->last_name}}</td>
                                <td>{{$employee->email}}</td>
                                <td>{{$employee->phone}}</td>
                                <td>{{$employee->company->name}}</td>
                                <td>
                                    <div class="btn-group">
                                        <a href="{{route('employees.edit',['employee' => $employee->id])}}" class="btn btn-primary">Edit</a>
                                        <a onclick="event.preventDefault();
                                                     document.getElementById('delete-employee').submit();" class="btn btn-danger">Delete</a>
                                    </div>
                                    <form id="delete-employee" action="{{route('employees.destroy', ['employee' => $employee->id])}}" method="POST" class="d-none">
                                        @csrf
                                        {{ method_field('DELETE') }}
                                    </form>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                    <div class="pagination mt-5">
                        {{ $employees->links() }}
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection